
package de.ivu.elect.presentation.veranstaltung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungConversationStore;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungExtendedDAO;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungEdit;
import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.business.veranstaltung.entity.VeranstaltungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractVeranstaltungEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractVeranstaltungEditNoScopeView.VIEW_ID, useCase = UseCasePermission.VERANSTALTUNG_EDIT)
public abstract class AbstractVeranstaltungEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Veranstaltung>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "veranstaltungEditView";

  public static final String VIEW_ID = "/veranstaltung/veranstaltung-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/veranstaltung/veranstaltung-search.xhtml";

  @Inject
  protected transient VeranstaltungExtendedDAO extendedDAO;

  @Inject
  protected transient VeranstaltungEdit edit;

  @Inject
  @ConversationGroup(VeranstaltungConversationStore.class)
  protected transient VeranstaltungConversationStore conversationStore;

  @Inject
  protected transient VeranstaltungMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient VeranstaltungEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Veranstaltung getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Veranstaltung entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.VERANSTALTUNG_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Veranstaltung entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.VERANSTALTUNG_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.VERANSTALTUNG_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.VERANSTALTUNG_EDIT)
  @Override
  public String save() {
    Veranstaltung entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Veranstaltung entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Veranstaltung entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Veranstaltung entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.VERANSTALTUNG_EDIT);
  }
  
  @Redirect
  public String edit(Veranstaltung entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class VeranstaltungEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Veranstaltung,   de.ivu.elect.business.veranstaltung.entity.VeranstaltungPK  > {

    private static final long serialVersionUID = 1L;
  }
}
